#! /bin/bash
# tarea 1 programacion de sistemas
# hecha por Javier Gonzalez Ovalle
# desarrollado en kubuntu (kernel 2.6.20-16)
# version modificada para su compatibilidad con aragorn
maquina=$1
url=$2
servm=$3
emaildest=$4
timenotif=$5

mesant=0
diaant=0
horaant=0
cond=1

echo 'HELO elo.utfsm.cl' > mensajemail.txt
echo 'MAIL FROM: msl@monitor.cl' >> mensajemail.txt
echo 'RCPT TO: '$emaildest >> mensajemail.txt
echo 'DATA' >> mensajemail.txt
echo 'Subject: Informe del Monitor de Servicios en Línea'>> mensajemail.txt
echo 'From: msl@monitor.cl' >> mensajemail.txt
echo 'To: '$emaildest >> mensajemail.txt

ifs=$IFS       # Save normal IFS in case we need it later
#Se usan de separadores el porcentaje, la coma y el espacio
IFS=", %"

while [ $cond = 1 ] ; do

# con el archivo loadavg obtenemos 
#la carga promedio de la CPU (alternativa a top y uptime)

cpu1m=`cat /proc/loadavg | gawk {'print $1'}`
cpu5m=`cat /proc/loadavg | gawk {'print $2'}`
cpu15m=`cat /proc/loadavg | gawk {'print $3'}`


# se indica la carga de la cpu y se guarda en un archivo txt
echo 'Nivel de carga promedio del procesador el último minutos: ' > cargacpu.txt
echo 'en 1 minuto:   ' $cpu1m'*100%' >> cargacpu.txt
echo 'en 5 minutos:  ' $cpu5m'*100%' >> cargacpu.txt
echo 'en 15 minutos: ' $cpu15m'*100%' >> cargacpu.txt


# hace un ping y los datos se guardan en un archivo
ping -c 3 $maquina | tee /tmp/r$$ | grep 'packet loss' > /tmp/p$$

#para sacar el rtt por una T guardamos la informacion en otro archivo
rttavg=`cat /tmp/r$$ | grep 'round-trip' | gawk -F / {'print $4'}`

rm /tmp/r$$ # que luego se borra

# del archivo temporal se saca la informacion correspondiente 
# al porcentaje de la perdida de paquetes

read crap1 crap2 crap3 crap4 crap5 crap6 lostpacket crap8 < /tmp/p$$
#lostpacket= cat /tmp/p$$ | gawk {'print $6'} | gawk -F % {'print ($1)'}

# este porcentaje lo asociamos a un estado, en caso de una conxion regular
# se indica el valor de la perdida de paquetes

if [ $lostpacket = 0 ]; then 
echo 'Conectividad hacia '$maquina' esta OK, con un rtt promedio: '$rttavg > pingresp.txt
elif [ $lostpacket = 100 ]; then
echo 'No hay conectividad con '$maquina > pingresp.txt
else
echo 'Hay un '$lostpacket'% de perdida de paquetes en la conexion con '$maquina', con un rtt promedio: '$rttavg > pingresp.txt
fi 

rm /tmp/p$$ #se elimina el archivo para saber el estado de la conexion

#se mezclan los 2 archivos en uno,
cat cargacpu.txt pingresp.txt > logmsl.txt
rm cargacpu.txt 
rm pingresp.txt

# revision de modificacion de la web por telnet
# echo $url
 ./feeder.sh < head.txt | telnet $url 80 | grep 'Last-Modified'> /tmp/d$$

mespost=`cat /tmp/d$$ | gawk {'print $4'}`
diapost=`cat /tmp/d$$ | gawk {'print $3'}`
horapost=`cat /tmp/d$$ | gawk {'print $6'}`

rm /tmp/d$$

# 	while [ $mesant != 0 ] && [ $diaant != 0 ] && [ $horaant != 0 ];do 

# 		if $mesant= 0 ; then
# 			echo 'Primera vez que se corre el programa, se suponen no cambios' > weblog.txt
# 			mesant=$mespost
		
		if [ $mesant = $mespost ] && [ $diaant = $diapost ] && [ $horaant = $horapost ]; then
			echo 'No hubo modificacion en la web con direccion '$url > weblog.txt
		
		else
			echo 'Se ha cambiado la web '$url > weblog.txt
	
		fi	

	mesant=$mespost
	diaant=$diapost 
	horaant=$horapost

# echo $mesant
# echo $diaant
# echo $horaant

cat weblog.txt >> logmsl.txt
rm weblog.txt

cat logmsl.txt >> mensajemail.txt
rm logmsl.txt
echo '--' >> mensajemail.txt
echo 'El equipo MSL le agradece su preferencia' >> mensajemail.txt
echo '.' >> mensajemail.txt
echo 'QUIT' >> mensajemail.txt
cat mensajemail.txt

./feeder.sh < mensajemail.txt | telnet $servm 25

rm mensajemail.txt
sleep $timenotif'm' #se pone 'm' para minutos de espera


done

IFS=$ifs # se restauran las modificaciones al IFS







